/**
 * Ext GWT 3.0.0-beta4 - Ext for GWT
 * Copyright(c) 2007-2011, Sencha, Inc.
 * licensing@sencha.com
 *
 * http://sencha.com/license
 */
package com.sencha.gxt.widget.core.client;

import com.google.gwt.core.client.GWT;

/**
 * A {@link TabPanel} with a plain tab bar, with no background behind each tab.
 */
public class PlainTabPanel extends TabPanel {

  /**
   * An appearance applicable to a {@link PlainTabPanel}.
   *
   * This interface exists so that the appropriate appearance can be substituted
   * through deferred binding depending on the theme in use. For example, a
   * blue-colored theme could substitute a blue {@code PlainTabPanel}
   * appearance. In functionality, a {@link PlainTabPanelAppearance} is
   * equivalent to a {@link TabPanel.TabPanelAppearance}.
   */
  public interface PlainTabPanelAppearance extends TabPanelAppearance {
  }

  public PlainTabPanel() {
    super(GWT.<PlainTabPanelAppearance> create(PlainTabPanelAppearance.class));
  }

  public PlainTabPanel(PlainTabPanelAppearance appearance) {
    super(appearance);
  }

}
